Search
j0ke.net Open Build Service
>
Projects
>
server:database
:
mongodb
:
2.4
>
mongodb
> mongodb.init
Sign Up
|
Log In
Username
Password
Cancel
Overview
Repositories
Revisions
Requests
Users
Advanced
Attributes
Meta
File mongodb.init of Package mongodb (Revision 7)
Currently displaying revision
7
,
show latest
#!/bin/sh # Copyright (c) 1995-2004 SUSE Linux AG, Nuernberg, Germany. # # Author: Andreas Schneider <asn@cynapses.org> # # /etc/init.d/mongodb # and its symbolic link # /(usr/)sbin/rcmongodb # # Template system startup script for some example service/daemon mongodb # # LSB compatible service control script; see http://www.linuxbase.org/spec/ # # Note: This template uses functions rc_XXX defined in /etc/rc.status on # UnitedLinux/SUSE/Novell based Linux distributions. If you want to base your # script on this template and ensure that it works on non UL based LSB # compliant Linux distributions, you either have to provide the rc.status # functions from UL or change the script to work without them. # See skeleton.compat for a template that works with other distros as well. # ### BEGIN INIT INFO # Provides: mongodb # Required-Start: $syslog $remote_fs # Should-Start: $time ypbind smtp # Required-Stop: $syslog $remote_fs # Should-Stop: ypbind smtp # Default-Start: 3 5 # Default-Stop: 0 1 2 6 # Short-Description: Start the mongodb a document-oriented database. # Description: Start the mongodb a document-oriented database. ### END INIT INFO # Check for missing binaries (stale symlinks should not happen) # Note: Special treatment of stop for LSB conformance mongodb_BIN=/usr/sbin/mongod mongodb_CONFIG=/etc/mongodb.conf test -x ${mongodb_BIN} || { echo "${mongodb_BIN} not installed"; if [ "$1" = "stop" ]; then exit 0; else exit 5; fi; } # This verifies the existence of numactl as well as testing that the command works numactl_BIN=/usr/bin/numactl numactl_ARGS="--interleave=all" if [ -x ${numactl_BIN} ] && ${numactl_BIN} ${numactl_ARGS} ls / >/dev/null 2>/dev/null then numactl="${numactl_BIN} ${numactl_ARGS}" else numactl="" fi # avoid hitting virtual memory limits with mmaps (bnc#876326) ulimit -v unlimited # Source LSB init functions # providing start_daemon, killproc, pidofproc, # log_success_msg, log_failure_msg and log_warning_msg. # This is currently not used by UnitedLinux based distributions and # not needed for init scripts for UnitedLinux only. If it is used, # the functions from rc.status should not be sourced or used. #. /lib/lsb/init-functions # Shell functions sourced from /etc/rc.status: # rc_check check and set local and overall rc status # rc_status check and set local and overall rc status # rc_status -v be verbose in local rc status and clear it afterwards # rc_status -v -r ditto and clear both the local and overall rc status # rc_status -s display "skipped" and exit with status 3 # rc_status -u display "unused" and exit with status 3 # rc_failed set local and overall rc status to failed # rc_failed <num> set local and overall rc status to <num> # rc_reset clear both the local and overall rc status # rc_exit exit appropriate to overall rc status # rc_active checks whether a service is activated by symlinks . /etc/rc.status # Reset status of this service rc_reset # Return values acc. to LSB for all commands but status: # 0 - success # 1 - generic or unspecified error # 2 - invalid or excess argument(s) # 3 - unimplemented feature (e.g. "reload") # 4 - user had insufficient privileges # 5 - program is not installed # 6 - program is not configured # 7 - program is not running # 8--199 - reserved (8--99 LSB, 100--149 distrib, 150--199 appl) # # Note that starting an already running service, stopping # or restarting a not-running service as well as the restart # with force-reload (in case signaling is not supported) are # considered a success. case "$1" in start) echo -n "Starting mongodb " ## Start daemon with startproc(8). If this fails ## the return value is set appropriately by startproc. LOGDIR="`sed -n 's|^[[:blank:]]*logpath[[:blank:]]*=[[:blank:]]*||p' "$mongodb_CONFIG" | tail -n 1`" LOGDIR="`dirname "$LOGDIR"`" if [ "$LOGDIR" ] && [ \! -e "$LOGDIR" ]; then mkdir -p "$LOGDIR" chown mongodb:mongodb "$LOGDIR" fi DBDIR="`sed -n 's|^[[:blank:]]*dbpath[[:blank:]]*=[[:blank:]]*||p' "$mongodb_CONFIG" | tail -n 1`" if [ "$DBDIR" ] && [ \! -e "$DBDIR" ]; then mkdir -p "$DBDIR" chown mongodb:mongodb "$DBDIR" fi ${numactl} /sbin/startproc -u mongodb -g mongodb ${mongodb_BIN} --quiet \ -f "$mongodb_CONFIG" # Remember status and be verbose rc_status -v ;; stop) echo -n "Shutting down mongodb " ## Stop daemon with killproc(8) and if this fails ## killproc sets the return value according to LSB. /sbin/killproc -TERM $mongodb_BIN # Remember status and be verbose rc_status -v ;; try-restart|condrestart) ## Do a restart only if the service was active before. ## Note: try-restart is now part of LSB (as of 1.9). ## RH has a similar command named condrestart. if test "$1" = "condrestart"; then echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}" fi $0 status if test $? = 0; then $0 restart else rc_reset # Not running is not a failure. fi # Remember status and be quiet rc_status ;; restart) ## Stop the service and regardless of whether it was ## running or not, start it again. $0 stop $0 start # Remember status and be quiet rc_status ;; force-reload) ## Signal the daemon to reload its config. Most daemons ## do this on signal 1 (SIGHUP). ## If it does not support it, restart the service if it ## is running. echo -n "Reload service mongodb " ## if it supports it: /sbin/killproc -HUP ${mongodb_BIN} #touch /var/run/mongodb.pid rc_status -v ## Otherwise: #$0 try-restart #rc_status ;; reload) ## Like force-reload, but if daemon does not support ## signaling, do nothing (!) # If it supports signaling: echo -n "Reload service mongodb " /sbin/killproc -HUP ${mongodb_BIN} #touch /var/run/mongodb.pid rc_status -v ## Otherwise if it does not support reload: #rc_failed 3 #rc_status -v ;; status) echo -n "Checking for service mongodb " ## Check status with checkproc(8), if process is running ## checkproc will return with exit status 0. # Return value is slightly different for the status command: # 0 - service up and running # 1 - service dead, but /var/run/ pid file exists # 2 - service dead, but /var/lock/ lock file exists # 3 - service not running (unused) # 4 - service status unknown :-( # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.) # NOTE: checkproc returns LSB compliant status values. /sbin/checkproc ${mongodb_BIN} # NOTE: rc_status knows that we called this init script with # "status" option and adapts its messages accordingly. rc_status -v ;; *) echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload}" exit 1 ;; esac rc_exit